/* 
 * EA878 - Lab. Micro e Mini: Software
 *
 * Processamento do protocolo HTTP 1.1 com lex e yacc
 *
 * Eleri Cardozo, Marco A. A. Henriques
 */


%{
#include "y.tab.h"
extern int lineno;
%}

%%

"GET "       return GET;       /* requests */
"HEAD "      return HEAD;
"OPTIONS "   return OPTIONS;
"TRACE "     return TRACE;
"POST "      return POST;
"PUT "       return PUT;
"DELETE "    return DELETE;
"VERSION "   return VERSION;


"HTTP/1.1"   return VERSION11;   /* http version */


"Connection: "        return CONNECTION;  /* parameters */
"Host: "              return HOST;        /* mandatory for HTTP 1.1 */
"Accept: "            return ACCEPT;
"User-Agent: "        return USER_AGENT;
"Accept-Encoding: "   return ACCEPT_ENCODING;
"Accept-Language: "   return ACCEPT_LANGUAGE;
"Accept-Charset: "    return ACCEPT_CHARSET;
"Keep-Alive: "        return KEEP_ALIVE;
"If-Modified-Since: " return IF_MODIFIED_SINCE;
"Cache-Control: "     return CACHE_CONTROL;
"Referer: "           return REFERER;
"TE: "                return TE;
"Authorization: "     return AUTHORIZATION;
"Cookie: "            return COOKIE;
"Pragma: "            return PRAGMA;


\n         {lineno++; return NL;}  /* newline */
\r         return CR;              /* carriage return */
\n\n       return END;             /* end of HTTP command */
\n\r\n     return END;             /* end of HTTP command */
,          return COMMA;           /* value, value */
[/]        return SLASH;           /* / */
[ ]        return BLANK;           /* blank space */
\t	   return BLANK;
.          {yylval.text = yytext[0]; return CHARACTER;}    /* anything else */

%%
